import { DirectionBurger } from '../components/direction-burger.js';
import { bar, createTemplate, createRoot, getStyles, setStyles } from '../utils/dom.js';
const tpl = createTemplate(`${bar}${bar}${bar}`);
export class Turn extends DirectionBurger {
    constructor() {
        super();
        this._styles = getStyles(createRoot(this, tpl));
    }
    get lines() {
        return 3;
    }
    render(options) {
        const { barHeight, barStyles, margin, move, pressed, time, topOffset } = options;
        const isLeft = this.direction === 'left';
        const transition = `${time}s ${this.easing}`;
        this.style.transition = transition;
        setStyles(this._styles[0], {
            ...barStyles,
            top: `${topOffset}px`,
            transition,
            transform: `${pressed ? `rotate(${45 * (isLeft ? -1 : 1)}deg) translate(${move * (isLeft ? -1 : 1)}px, ${move}px)` : 'none'}`
        });
        setStyles(this._styles[1], {
            ...barStyles,
            top: `${topOffset + barHeight + margin}px`,
            transition: `${time / 2}s ${this.easing}`,
            transform: `${pressed ? 'scaleX(0)' : 'none'}`
        });
        setStyles(this._styles[2], {
            ...barStyles,
            top: `${topOffset + barHeight * 2 + margin * 2}px`,
            transition,
            transform: `${pressed
                ? `rotate(${45 * (isLeft ? 1 : -1)}deg) translate(${move * (isLeft ? -1 : 1)}px, ${move * -1}px)`
                : 'none'}`
        });
    }
}
//# sourceMappingURL=turn.js.map